# Создание и развёртывание бота.

В первую очередь, _почему же нужно создавать именно своего бота?_
- Ограничения <a href="https://core.telegram.org/bots/faq#broadcasting-to-users" target="_blank">Telegram</a>
- Ограничения <a href="https://vk.com/dev/api_requests?f=3.1.%20%D0%A7%D0%B0%D1%81%D1%82%D0%BE%D1%82%
D0%BD%D1%8B%D0%B5%20%D0%BE%D0%B3%D1%80%D0%B0%D0%BD%D0%B8%D1%87%D0%B5%D0%BD%D0%B8%D1%8F" target="_blank">VK</a>
- Гарантия сохранности переписки и полного контроля над ботом

Бот имеет полностью открытый исходный код, с которым можно ознакомиться перейдя по ссылке _View on GitHub_ в верхнем углу станицы.

## Heroku

Развёртывать бота мы будем на Heroku, поэтому там нужно завести аккаунт <a href="https://heroku.com" target="_blank">heroku.com</a>

Т.к мы будем использовать бесплатный тип хостинга, то на него накладываются некоторые <a href="https://core.telegram.org/bots/faq#broadcasting-to-users" target="_blank">ограничения</a>, дабы частично их смягчить можно <a href="https://dashboard.heroku.com/account/billing" target="_blank">привязать карту</a> (никаких плат не взимается), тогда бот сможет работать полный месяц без остановок (а не предусмотренные 500ч/мес изначально)

Подробнее можно ознакомиться <a href="https://devcenter.heroku.com/articles/free-dyno-hours" target="_blank">тут</a> 

## VK

По <a href="https://vk.com/editapp?act=create" target="_blank">ссылке</a> нужно создать своё Standalone-приложение, затем во вкладке _Настройки_ перевести _Состояние_ в _Приложение включено и видно всем_, а так же _Включить_ _Open API_, не забудьте сохранить изменения!

На этом этапе мы сохраняем себе куда-нибудь **ID приложения**

## Telegram

<a href="https://t.me/BotFather" target="_blank">Создаём бота</a>, в качестве имени удобно будет использовать _VK_, юзернейм роли не играет. Сохраняем **токен бота**, который мы получили от BotFather

_Опционально:_

Настройка команд бота

```
dialogs - Список диалогов
search - Поиск диалогов
chat - Текущий чат
leave - Покинуть текущий чат
start - Подключить ВК
stop - Отключить ВК
```
[Логотип VK](vklogo.jpg) для аватарки бота.

<h2><a name="heroku--vk--telegram"></a>Heroku + VK + Telegram</h2>
Получив ID приложения и токен бота, можно смело начинать развёртывать бота на Heroku.

Нажав на кнопку ниже вы попадёте на страницу развёртывания, где будут поля:

[![Deploy](https://www.herokucdn.com/deploy/button.svg)](https://heroku.com/deploy?template=https://github.com/Kylmakalle/tgvkbot/tree/master)
- **Имя приложения** - можно оставить пустым, Heroku выберет за вас.
- **Регион развёртывания** - выбираем Европу, чтобы бот был пошустрее.
- **Telegram API Token** - токен бота полученный ранее.
- **VK APP ID** - ID приложения ВКонтакте полученный ранее.



После успешного развёртывания можно смело пользоваться ботом.


Если вы вдруг что-то напутали с токеном и/или ID, их всегда можно настроить перейдя в _Settings->Config Vars_ соответствующего приложения в своей панели управления <a href="https://dashboard.heroku.com/ " target="_blank">dashboard.heroku.com</a>

Если всё прошло гладко, то можно ознакомиться с [Использованием](/tgvkbot/usage/README.md)

## Обновление
Обо всех **ВАЖНЫХ** обновлениях можно будет узнать в <a href="https://t.me/tg_vk" target="_blank">Telegram канале</a>

К сожалению простого механизма обновления бота нет и не предусмотрено, поэтому единственный способ - повторное <a href="#heroku--vk--telegram">развёртывание</a> бота не Heroku с уже имеющимися токеном бота и ID приложения из VK.
